/* s0.cpp bubble sort with c++ string swap */

#include <iostream>
#include <fstream>
#include <ctime>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

using namespace std; 

ofstream outFile("out0.txt"); 

static LARGE_INTEGER listart;
static LARGE_INTEGER listop;

int compStr(string a, string b){
    size_t l = a.length();
    for(size_t i = 0; i < l; i++){
        if(a[i] == b[i])
            continue;
        if (a[i] < b[i]) return(-1);
        else return(1); 
    }
    return(0); 
}

void bubbleSort(string * ar, int n){
    QueryPerformanceCounter(&listart);
    bool b = true; 
    for (int j = n-1; j > 0 && b; j--){
        b = false;  
        for (int i = 0; i < j; i++){
            if (compStr(ar[i], ar[i+1]) > 0){
                ar[i].swap(ar[i+1]);
                b = true;
            }
        }
    }

    QueryPerformanceCounter(&listop);
    outFile << (listop.QuadPart - listart.QuadPart) << endl;    
    outFile.flush();        
}

string getRandomStr(int n){
    string s; 
    for (int i =  0; i < n; i++){       
        s += (char) (rand() % 26 + 65);
    }
    return (s); 
}

void testSort(int n){
    string * a = new string[n];
//  int l = 20000 - n*10;
    int l = 10000000/n;
    for (int i = 0; i < n; i++){
        a[i]= getRandomStr(l);
    }
    
    outFile << n << ' ';
    bubbleSort(a, n); 
    delete [] a;
}

int main (int argc, char ** argv){
    int n = 2000;
    for (int i = 10; i < n; i += 10){   
        testSort(i);
        cout << '\r' << (double) i / (double) n;
    }
    return (0);
} 
