/* s2.cpp bubble sort with pointer swap */

#include <iostream>
#include <fstream>
#include <ctime>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

using namespace std; 

ofstream outFile("out2.txt"); 

static char *pmem;
static char *aps[1000000];
static LARGE_INTEGER listart;
static LARGE_INTEGER listop;

int compStr(char *a, char *b, int l){
    for(int i = 0; i < l; i++){
        if(a[i] == b[i])
            continue;
        if (a[i] < b[i]) return(-1);
        else return(1); 
    }
    return(0); 
}

void bubbleSort(int n, int l){
    QueryPerformanceCounter(&listart);
    char * pt;
    bool b = true; 
    for (int j = n-1; j > 0 && b; j--){
        b = false;  
        for (int i = 0; i < j; i++){
            if (compStr(aps[i], aps[i+1], l)>0){
                pt = aps[i];
                aps[i] = aps[i+1];
                aps[i+1]= pt;
                b = true;
            }
        }
    }
    QueryPerformanceCounter(&listop);

    outFile << (listop.QuadPart - listart.QuadPart) << endl;    
    outFile.flush();        
}

void setRandomStr(char * ps, int n){
    for (int i =  0; i < n; i++){       
        ps[i]= (char) (rand() % 26 + 65);
    }
}

void testSort(int n){
    char *ps = pmem;
    int l = 10000000/n;
    for (int i = 0; i < n; i++){
        aps[i] = ps;
        setRandomStr(aps[i], l);
        ps += l;
    }
    
    outFile << n << ' ';
    bubbleSort(n, l); 
}

int main (int argc, char ** argv){
    pmem = (char *)malloc(10000000);
    int n = 2000;
    for (int i = 10; i < n; i += 10){   
        testSort(i);
        cout << '\r' << (double) i / (double) n;
    }
    free(pmem);
    return (0);
} 
